"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.axiosGet = exports.shuffleList = exports.downloadAndSaveJsonFile = exports.isValidIPv4 = void 0;
const axios_1 = __importDefault(require("axios"));
const fs = __importStar(require("fs"));
const isValidIPv4 = (ip) => {
    if (ip === 'localhost') {
        return true;
    }
    const parts = ip.split('.');
    if (parts.length !== 4) {
        return false;
    }
    return parts.every((part) => {
        const num = parseInt(part, 10);
        return num >= 0 && num <= 255;
    });
};
exports.isValidIPv4 = isValidIPv4;
const downloadAndSaveJsonFile = (url, filePath) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        const response = yield axios_1.default.get(url);
        const jsonData = response.data;
        const jsonString = JSON.stringify(jsonData, null, 2);
        // eslint-disable-next-line security/detect-non-literal-fs-filename
        fs.writeFileSync(filePath, jsonString, 'utf-8');
        console.log(`Downloaded JSON data from URL ${url} and saved to file ${filePath}`);
    }
    catch (error) {
        console.error(`Failed to download and save JSON data from URL ${url} to file ${filePath}: ${error}`);
    }
});
exports.downloadAndSaveJsonFile = downloadAndSaveJsonFile;
/* eslint-disable security/detect-object-injection */
function shuffleList(list) {
    const shuffledList = [...list];
    for (let i = shuffledList.length - 1; i > 0; i--) {
        const j = Math.floor(Math.random() * (i + 1));
        [shuffledList[i], shuffledList[j]] = [shuffledList[j], shuffledList[i]];
    }
    return shuffledList;
}
exports.shuffleList = shuffleList;
/* eslint-enable security/detect-object-injection */
const axiosGet = (url, config) => __awaiter(void 0, void 0, void 0, function* () {
    const response = axios_1.default.get(url, config);
    return response;
});
exports.axiosGet = axiosGet;
//# sourceMappingURL=utils.js.map